/**
 * $Id: dir_ite.cc,v 1.2 2003/10/13 22:54:34 i Exp $
 *
 * Copyright (C) shinichiro.h <s31552@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~s31552/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "dir_ite.h"

#include "cpputil.h"

#include <dirent.h>

Dir::Dir(std::string path)
	: path_(path)
{
	DIR* dir = opendir(path.c_str());
	check(dir != 0, path + ": dir not found.");

	while (dirent* d = readdir(dir)) {
		std::string name(d->d_name);
		if (name == "." || name == "..") continue;
		files_.push_back(name);
	}

	closedir(dir);
}

